﻿using System;
using System.ComponentModel;
using System.Data;
using System.Windows.Forms;
using Telerik.WinControls.Data;
using Telerik.WinControls.UI;

namespace CheckedGroupHeaderCellElement
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.radGridView1.CreateCell += new Telerik.WinControls.UI.GridViewCreateCellEventHandler(radGridView1_CreateCell);
        }

        void radGridView1_CreateCell(object sender, Telerik.WinControls.UI.GridViewCreateCellEventArgs e)
        {
            if (e.CellType == typeof(GridGroupContentCellElement))
            {
                e.CellType = typeof(CustomGroupHeaderCell);
            }
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            this.radGridView1.DataSource = this.GetTable();
            this.radGridView1.AutoExpandGroups = true;

            GroupDescriptor groupDescriptor = new GroupDescriptor(new SortDescriptor("Company",
                                                                       ListSortDirection.Ascending));

            this.radGridView1.GroupDescriptors.Add(groupDescriptor);
        }

        private DataTable GetTable()
        {
            DataTable table = new DataTable("table");

            table.Columns.Add("ID", typeof(int));
            table.Columns.Add("Name", typeof(string));
            table.Columns.Add("Salary", typeof(decimal));
            table.Columns.Add("Company", typeof(string));
            table.Columns.Add("DateOfBirth", typeof(DateTime));


            table.Rows.Add(1, "John", 20000, "Google", DateTime.Now.AddYears(-20));
            table.Rows.Add(2, "Mike", 70000, "Telerik", DateTime.Now.AddYears(-30));
            table.Rows.Add(3, "Richarg", 90000, "Google", DateTime.Now.AddYears(-50));
            table.Rows.Add(4, "Ervin", 20000, "Apple", DateTime.Now.AddYears(-40));
            table.Rows.Add(5, "Jack", 40000, "Google", DateTime.Now.AddYears(-22));
            table.Rows.Add(6, "Michael", 50000, "Apple", DateTime.Now.AddYears(-33));
            table.Rows.Add(7, "Todd", 60000, "Apple", DateTime.Now.AddYears(-45));
            table.Rows.Add(8, "Steve", 57000, "Telerik", DateTime.Now.AddYears(-33));
            table.Rows.Add(9, "Doug", 32000, "Telerik", DateTime.Now.AddYears(-30));
            table.Rows.Add(10, "Peter", 49000, "Google", DateTime.Now.AddYears(-26));
            table.Rows.Add(11, "Donald", 87000, "Google", DateTime.Now.AddYears(-29));
            table.Rows.Add(12, "Patric", 66000, "Apple", DateTime.Now.AddYears(-60));
            table.Rows.Add(13, "Anthony", 410000, "Microsoft", DateTime.Now.AddYears(-62));
            table.Rows.Add(14, "Jason", 56000, "Telerik", DateTime.Now.AddYears(-65));
            table.Rows.Add(15, "Jim", 74000, "Amazon", DateTime.Now.AddYears(-54));
            table.Rows.Add(16, "Nick", 23000, "Amazon", DateTime.Now.AddYears(-30));
            table.Rows.Add(17, "Oliver", 59000, "Microsoft", DateTime.Now.AddYears(-40));

            return table;
        }
    }
}
